# -*- coding: utf-8 -*-

import sys
import os
import datetime
import pkg_resources

from distutils.version import LooseVersion

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
sys.path.append(os.path.abspath('_themes'))

# -- General configuration -----------------------------------------------------

extensions = ['sphinx.ext.autodoc', 'sphinxcontrib.blockdiag', 'sphinx.ext.mathjax']
templates_path = ['_templates']
source_suffix = '.rst'
master_doc = 'index'

# ADJUST IT TO FIT YOUR NEEDS!1
# blockdiag_fontpath = '/usr/share/fonts/truetype/ipafont/ipagp.ttf'
blockdiag_fontpath = '/Users/ich/Library/Fonts/DejaVuSans-Bold.ttf'

# General information about the project.
project = u'Acrylamid'
copyright = u'%i, Martin Zimmermann' % datetime.date.today().year

release = pkg_resources.get_distribution("acrylamid").version  # 0.6, 0.6.1, 0.7 or 0.7.1
version = '%i.%i' % tuple(LooseVersion(release).version[:2])  # 0.6 or 0.7

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#language = None

exclude_patterns = ['_build']

html_theme = 'werkzeug'
html_theme_path = ['_themes']
html_static_path = ['_static']

htmlhelp_basename = 'acrylamiddoc'

# -- Options for LaTeX output --------------------------------------------------

latex_documents = [
  ('index', 'acrylamid.tex', u'Acrylamid Documentation',
   u'Martin Zimmermann', 'manual'),
]

# The name of an image file (relative to this directory) to place at the top of
# the title page.
#latex_logo = None

# For "manual" documents, if this is true, then toplevel headings are parts,
# not chapters.
#latex_use_parts = False

# If true, show page references after internal links.
#latex_show_pagerefs = False

# If true, show URL addresses after external links.
#latex_show_urls = False

# Additional stuff for the LaTeX preamble.
#latex_preamble = ''

# Documents to append as an appendix to all manuals.
#latex_appendices = []

# If false, no module index is generated.
#latex_domain_indices = True


# -- Options for manual page output --------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    ('index', 'acrylamid', u'Acrylamid Documentation',
     [u'Martin Zimmermann'], 1)
]

# -- http://stackoverflow.com/questions/7825263/including-docstring-in-sphinx-documentation --
from sphinx.ext import autodoc

class SimpleDocumenter(autodoc.ClassDocumenter):
    objtype = "simple"

    #do not indent the content
    content_indent = ""

    #do not add a header to the docstring
    def add_directive_header(self, sig):
        pass

def setup(app):
    app.add_autodocumenter(SimpleDocumenter)
